searchData={"items":[{"type":"module","title":"MapTransform","doc":"This is a simple library that can transform one map into another through\nmapping rules.","ref":"MapTransform.html"},{"type":"type","title":"MapTransform.mapping/0","doc":"","ref":"MapTransform.html#t:mapping/0"},{"type":"type","title":"MapTransform.path/0","doc":"","ref":"MapTransform.html#t:path/0"},{"type":"function","title":"MapTransform.transform/2","doc":"Transform one map into another.","ref":"MapTransform.html#transform/2"},{"type":"function","title":"Format for mappings - MapTransform.transform/2","doc":"For the paths is the standard that `get_in/2` and `put_in/2` use.\nFor example to get data from `c` in `%{a: %{b: %{c: 1}}}` you would provide\n`[:a, :b, :c]` as the path.\n\nThen we'll use these paths in the mapping in a list of tuples where:\n\n    {from_path, to_path}\n    {from_path, to_path, &transform_function/1}","ref":"MapTransform.html#transform/2-format-for-mappings"},{"type":"function","title":"Example - MapTransform.transform/2","doc":"Basic\n\n    iex> mapping = [\n    ...>   {[:a, :b, :c], [:abc]}\n    ...> ]\n    ...> source = %{a: %{b: %{c: 1}}}\n    ...> transform(source, mapping)\n    %{abc: 1}\n\n\nString keys and using a transform function\n\n    iex> mapping = [\n    ...>   {[\"a\", \"b\", \"c\"], [:abc], &String.to_integer/1}\n    ...> ]\n    ...> source = %{\"a\" => %{\"b\" => %{\"c\" => \"1\"}}}\n    ...> transform(source, mapping)\n    %{abc: 1}\n\n\nAny nesting\n\n    iex> mapping = [\n    ...>   {[:a, :b, :c], [:foo, :bar]}\n    ...> ]\n    ...> source = %{a: %{b: %{c: 1}}}\n    ...> transform(source, mapping)\n    %{foo: %{bar: 1}}","ref":"MapTransform.html#transform/2-example"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}